<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Relay Control Configuration</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}

		.onOffLabel {
			color: brown;
			font-weight: bold;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
				<h5 class="p-1">Relay/Output Control Configuration</h5>
				<form id="formID">
					<div class="border border-primary p-2">
						<!-- Enable Relay-1 -->
						<div class="input-group p-0 m-1 row">
							<div class="input-group-prepend">
								<div class="input-group-text">
									<input type="checkbox" id="relay1_enabled">
								</div>
							</div>
							<label type="text" class="form-control">Enable Relay-1</label>
						</div>

						<div class="output_settings">
							<!-- Packet version -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="packet_version">Packet version</label>
								<input type="text" id="packet_version" class="col-6 form-control form-control-sm"
									readonly>
							</div>


							<!-- Set Point On -->
							<div class="form-group p-0 m-1 row">
								<label class="col-12" style="font-size:xx-small">Set point can be between 5 (0.5%) to 995(99.5%)</label>
								<label class="col-12" style="font-size:xx-small"> Eg: 80.5% entered as 805, 9% entered as 90</label>
							</div>							

							<!-- Set Point On -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_set_point_on">Set Point ON</label>
								<input type="text" id="sel_set_point_on" name="sel_set_point_on"
									class="col-6 form-control form-control-sm hys_calc_class"
									data-validation-engine="validate[required], custom[integer], maxSize[4], min[5], max[995]">
							</div>

							<!-- Set Point Off -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_set_point_off">Set Point OFF</label>
								<input type="text" id="sel_set_point_off" name="sel_set_point_off"
									class="col-6 form-control form-control-sm hys_calc_class"
									data-validation-engine="validate[required], custom[integer], maxSize[4], min[5], max[995]">
							</div>

							<!-- On Delay- -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_delay_on">On Delay (secs)</label>
								<input type="text" id="sel_delay_on" name="sel_delay_on"
									class="col-6 form-control form-control-sm" readonly
									data-validation-engine="validate[required], custom[integer], min[0], max[99]">
							</div>

							<!-- Off Delay- -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_delay_off">Off Delay (secs)</label>
								<input type="text" id="sel_delay_off" name="sel_delay_off"
									class="col-6 form-control form-control-sm" readonly
									data-validation-engine="validate[required], custom[integer],min[0], max[99]"> </div>
						</div>

						<div class="col-sm-12 form-group row mt-4 mb-1">
							<button type="button" id="button_cancel"
								class="btn btn-warning col ml-4 mr-4">Cancel</button>
							<button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
						</div>
					</div>
				</form>
			</main>
		</div>
</body>
</html>

<script>
	w3IncludeHTML();

	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		$("#button_save").on("click", function () {
			if ($("#formID").validationEngine('validate')) {
				if (check_set_points() == true) {
					var r = confirm("Save Output Control configuration?");
					if (r == true) {
						save_config();
					}
				}
			}
		});

		function check_set_points() {
			sel_set_point_on = $("#sel_set_point_on").val();
			sel_set_point_off = $("#sel_set_point_off").val();

			if (sel_set_point_on == sel_set_point_off) {
				alert("Set Point ON and OFF cannot be same...");
				return false;
			}
			return true;
		}

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		$("#relay1_enabled").on("click", function () {
			enable_disable();
		});

		function enable_disable() {
			if ($('#relay1_enabled').is(":checked") == true) {
				$(".output_settings :input").attr("disabled", false);
			} else {
				$(".output_settings :input").attr("disabled", true);
			}
		}

		function load_form_data() {
			var out1 = g_out_ctrl_db.output_1;

			$("#packet_version").val(g_out_ctrl_db.pkt_ver);
			$('#relay1_enabled').prop("checked", out1.enabled);
			$("#sel_set_point_on").val(out1.set_point_on);
			$("#sel_set_point_off").val(out1.set_point_off);
			$("#sel_delay_on").val(out1.delay_on);
			$("#sel_delay_off").val(out1.delay_off);

			enable_disable();
		}

		function save_config() {
			var debug = 0;

			var out1 = g_out_ctrl_db.output_1;

			out1.enabled = $("#relay1_enabled").is(":checked");
			out1.set_point_on = $("#sel_set_point_on").val();
			out1.set_point_off = $("#sel_set_point_off").val();
			out1.delay_on = $("#sel_delay_on").val();
			out1.delay_off = $("#sel_delay_off").val();

			var url = "/updateOutCtrlConfig";
			var type = 'POST';
			var data = {
				outCtrl: JSON.stringify(g_out_ctrl_db)
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function noSensorData(response) {
			console.log("POST Error...")
		}

		function updateDevicesParams(response) {
			$("#sel_clientId").val(response.dev_id);
		}
		//********* Call all start up functions after this line *******//

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
		}, 500);

		setTimeout(function () {
			readOutCtrlConfigFromFS(load_form_data);
		}, 750);

		$("#formID").validationEngine();
	});

</script>